package fsmwizard

import (
	"gitea.neur0tx.site/Neur0toxine/vegapokerbot/pkg/fsm"
	"go.uber.org/zap"
)

type ErrorState struct {
	fsm.ErrorState[Wizard]
	log *zap.SugaredLogger
}

func NewErrorState(log *zap.SugaredLogger) *ErrorState {
	return &ErrorState{log: log}
}

func (s *ErrorState) Handle(err error, cur fsm.StateID, next fsm.StateID, pl *Wizard, mc fsm.MachineControls[Wizard]) {
	s.log.Errorf("critical wizard error: %s, current state: %s, next state: %s, payload: %#v",
		err, cur, next, pl)
	mc.Reset()
}
