package types

import (
	"github.com/stretchr/testify/assert"
	"testing"
)

func TestQueue(t *testing.T) {
	q := NewQueue[uint8]()
	assert.Equal(t, uint64(0), q.Len())
	assert.Equal(t, uint8(0), q.Dequeue())

	q.Enqueue(1)
	q.Enqueue(2)
	assert.Equal(t, uint64(2), q.Len())
	assert.Equal(t, uint8(1), q.Dequeue())
	assert.Equal(t, uint8(2), q.Dequeue())
	assert.Equal(t, uint8(0), q.Dequeue())
}
